/***********************************************************************
* FILENAME :        matrix.h 
*
* DESCRIPTION :
*        Matrix operations header file
*
* NOTES:
* 	     Warning! malloc defined for freeRTOS
*
* licensed under the Creative Commons Attribution-NonCommercial 4.0 
* 
* AUTHOR :    Romulo Antao        START DATE :    27 MAR 17
*
************************************************************************/

#ifndef MATRIX_H
#define MATRIX_H

/* Standard includes. */
#include <stdio.h>

/* Hardware Includes */
#include <math.h>

typedef struct {
    unsigned short rows;
    unsigned short cols;
    float **matrix;
}Matrix;

/* Function prototypes */
int matrix_init(Matrix *Mdst, int rows, int columns);

int matrix_MTM(Matrix *Msrc, Matrix *Mdst);
int matrix_sumdiag(Matrix *Msrc, float var, Matrix *Mdst);
int matrix_inv3x3(Matrix *Msrc, Matrix *Mdst);
int matrix_inv2x2(Matrix *Msrc, Matrix *Mdst);
int matrix_minus(Matrix *M1src, Matrix *M2src, Matrix *Mdst);
int matrix_sum(Matrix *M1src, Matrix *M2src, Matrix *Mdst);
int matrix_prod(Matrix *M1src, Matrix *M2src, Matrix *Mdst);
int matrix_scale(Matrix *Msrc, float var, Matrix *Mdst);

#endif