function [u] = gpc(y,u,r,a,b,Np,Nu,lambda)
% GPC implementation for ARX model

          a_tilde = [a 0] - [0 a];
           
          na = length(a);
          nb = length(b);
           
          % Implementa??o Eq. 6.20 Jerome
          f = zeros(Np,na);
          f(1,:) = -a_tilde(2:end);
           
          for p=2:Np
             for i=1:na-1
                   f(p,i)=f(p-1,i+1) - f(p-1,1)*a_tilde(i+1);
             end
             f(p,na)= - f(p-1,1)*a_tilde(na+1);
          end
           
                
          g = zeros(Np,Np+nb-1);
          g(1,:) = [b zeros(1,Np-1)];
   
          for p=2:Np
                g(p,:) = g(p-1,:);
                for i=1:nb
                    g(p,p+i-1) = g(p-1,p+i-1) +  f(p-1,1)*b(i);
                end
          end
   
          G = zeros(Np,Nu);
           

          for pp=1:Np
              i=pp;
              j=1;
              while(i>=1&&j<=Nu)
                  G(pp,j) = g(pp,i);
                  i=i-1;
                  j=j+1;
              end
          end
           
          F = f;
            
          L = zeros(Np,1);
           
          for p=1:Np
              L(p,1) = g(p,p+1);
          end
           
          % Get the control increment
           
          K = eye(Nu)/(G'*G+lambda*eye(Nu))*G';
           
          r_params  =  K(1,:);
          y_params  = -K(1,:)*F;
          u_params  =  K(1,:)*L;
           
          du = u(1)-u(2);
          u  = u(1) + r_params*r(:)+y_params*y(:)+u_params*du;
           
end