% licensed under the Creative Commons Attribution-NonCommercial 4.0 

function [u] = gpc_type1(u,y,r,du,C,fL,na,nb,Np,Nu,lambda)

    % Set input data columnwise
   u=u(:); y=y(:); r=r(:);
   
   %determinar os parametros al, ar, bl, br
   for i=1:nb
       b(:,i) = C(:,i);
   end
   
   for i=1:na
       a(:,i) = C(:,nb+i);
   end
   
   %multiplicar pelos graus de activacao
   b_w = fL*b/sum(fL);
   a_w = [1 -fL*a/sum(fL)];
   
   % GPC
   
   a_tilde = [a_w 0] - [0 a_w];
   
   na = na + 1;
   nb = nb;
   
   % Implementacao Eq. 6.20 Jerome
   f = zeros(Np,na);
   f(1,:) = -a_tilde(2:end);
   
   for p=2:Np
       for i=1:na-1
           f(p,i)=f(p-1,i+1) - f(p-1,1)*a_tilde(i+1);
       end
       f(p,na)= - f(p-1,1)*a_tilde(na+1);
   end
   
   % Implementacao Eq. 6.21
   g = zeros(Np,Np+nb-1);
   g(1,:) = [b_w zeros(1,Np-1)];
   
   for p=2:Np
       g(p,:) = g(p-1,:);
       for i=1:nb
           g(p,p+i-1) = g(p-1,p+i-1) +  f(p-1,1)*b_w(i);
       end
   end
   
   % Implementacao de G segundo pagina 132 Jerome
   G = zeros(Np,Nu);


    for pp=1:Np
        i=pp;
        j=1;
        while(i>=1&&j<=Nu)
            G(pp,j) = g(pp,i);
            i=i-1;
            j=j+1;
        end
    end
   
   % Implementacao de F segundo pagina 132 jerome
   F = f;
   
   % Implementacao de L segundo pagina 132 jerome
   L = zeros(Np,1);
   
   for p=1:Np
       L(p,1) = g(p,p+1);
   end
   
   % Get the control increment
   
   K = eye(Nu)/(G'*G+lambda*eye(Nu))*G';
   
   r_params  =  K(1,:);
   y_params  = -K(1,:)*F;
   u_params  = -K(1,:)*L;                                      
                           
   u = u(1) + r_params*r(:)+y_params*y(:)+u_params*du;
   
end