% licensed under the Creative Commons Attribution-NonCommercial 4.0 

function [y_pred] = nstep_pred_type1(u,y,du,C,fL,na,nb,Np)

   % Set input data columnwise
   u=u(:); y=y(:);
   
   %determinar os parametros al, ar, bl, br
   for i=1:nb
       b(:,i) = C(:,i);
   end
   
   for i=1:na
       a(:,i) = C(:,nb+i);
   end
   
   %multiplicar pelos graus de activacao
   b_w = fL*b/sum(fL);
   a_w = [1 -fL*a/sum(fL)];
   
   % GPC
   
   a_tilde = [a_w 0] - [0 a_w];
   
   na = length(a_w);
   nb = length(b_w);
   
   % Implementacao Eq. 6.20 Jerome
   f = zeros(Np,na);
   f(1,:) = -a_tilde(2:end);
   
   for p=2:Np
       for i=1:na-1
           f(p,i)=f(p-1,i+1) - f(p-1,1)*a_tilde(i+1);
       end
       f(p,na)= - f(p-1,1)*a_tilde(na+1);
   end
     
   % Implementacao Eq. 6.21
   g = zeros(Np,Np+nb-1);
   g(1,:) = [b_w zeros(1,Np-1)];
   
   for p=2:Np
       g(p,:) = g(p-1,:);
       for i=1:nb
           g(p,p+i-1) = g(p-1,p+i-1) +  f(p-1,1)*b_w(i);
       end
   end
   
   % Implementacao de G segundo pagina 132 Jerome
   G = zeros(Np,1);

   for pp=1:Np
      for i=pp:-1:1
          G(pp,1) = g(pp,i);
      end
   end
   
   % Implementacao de F segundo pagina 132 jerome
   F = f;
   
   % Implementacao de L segundo pagina 132 jerome
   L = zeros(Np,1);
   
   for p=1:Np
       L(p,1) = g(p,p+1);
   end
   
   % Get the Np step ahead prediction  
   y_params  = F;
   u_params = L;

   du = [du, zeros(1,Np-1)];     
   
   y_pred = y_params*y(:)+G(:,1)'*du(:);
   
   %Get the Np prediction
   y_pred = y_pred(Np);
    
end