% licensed under the Creative Commons Attribution-NonCommercial 4.0 

function [y_pred] = nstep_pred_type2(u,y,du,na,nb,C_r,C_l,wr,wl,Np)

    % Set input data columnwise
    u=u(:); y=y(:);

    %determinar os parametros al, ar, bl, br
    for i=1:nb
        br(:,i) = C_r(:,i);
        bl(:,i) = C_l(:,i);
    end

    for i=1:na
        ar(:,i) = C_r(:,nb+i);
        al(:,i) = C_l(:,nb+i);
    end

    % Multiplicar pelos graus de activacao wr e wl
    br_w = wr*br/sum(wr);
    ar_w = [1 -wr*ar/sum(wr)];

    bl_w = wl*bl/sum(wl);
    al_w = [1 -wl*al/sum(wl)];
    
    % GPC

    %% GPC for u_r
    a_tilde = [ar_w 0] - [0 ar_w];

    na = length(ar_w);
    nb = length(br_w);

    % Implementacao Eq. 6.20 Jerome
    f = zeros(Np,na);
    f(1,:) = -a_tilde(2:end);

    for p=2:Np
        for i=1:na-1
            f(p,i)=f(p-1,i+1) - f(p-1,1)*a_tilde(i+1);
        end
        f(p,na)= -f(p-1,1)*a_tilde(na+1);
    end

    % Implementacao Eq. 6.21
    g = zeros(Np,Np+nb-1);
    g(1,:) = [br_w zeros(1,Np-1)];
   
    for p=2:Np
        g(p,:) = g(p-1,:);
        for i=1:nb
            g(p,p+i-1) = g(p-1,p+i-1) +  f(p-1,1)*br_w(i);
        end
    end
     
    % Implementacao de G segundo pagina 132 Jerome
    G = zeros(Np,1);

    for pp=1:Np
       for i=pp:-1:1
           G(pp,1) = g(pp,i);
       end
    end

    % Implementacao de F segundo pagina 132 jerome
    F = f;

    % Implementacao de L segundo pagina 132 jerome
    L = zeros(Np,1);

    for p=1:Np
        L(p,1) = g(p,p+1);
    end

    % Get the right bound of the prediction
    y_params  = F;
    u_params = L;

    du = [du, zeros(1,Np-1)];     
   
    y_pred_r = y_params*y(:)+G(:,1)'*du(:);

    %% GPC for u_l
    a_tilde = [al_w 0] - [0 al_w];

    na = length(al_w);
    nb = length(bl_w);

    %Implementacao Eq. 6.20 Jerome
    f = zeros(Np,na);
    f(1,:) = -a_tilde(2:end);

    for p=2:Np
        for i=1:na-1
            f(p,i)=f(p-1,i+1) - f(p-1,1)*a_tilde(i+1);
        end
        f(p,na)= -f(p-1,1)*a_tilde(na+1);
    end

    % Implementacao Eq. 6.19 Jerome
    e = zeros(Np,Np);    % Eq. 6.25
    e(1,1) = 1;

    for p=2:Np
        e(p,:) = e(p-1,:);
        e(p,p) = e(p,p) + f(p-1,1);
    end

    % Implementacao Eq. 6.21
    g = zeros(Np,Np+nb-1);
    g(1,:) = [bl_w zeros(1,Np-1)];
   
    for p=2:Np
        g(p,:) = g(p-1,:);
        for i=1:nb
            g(p,p+i-1) = g(p-1,p+i-1) +  f(p-1,1)*bl_w(i);
        end
    end

    % Implementacao de G segundo pagina 132 Jerome
    G = zeros(Np,1);

    for pp=1:Np
       for i=pp:-1:1
           G(pp,1) = g(pp,i);
       end
    end
   
    % Implementacao de F segundo pagina 132 jerome
    F = f;

    % Implementacao de L segundo pagina 132 jerome
    L = zeros(Np,1);

    for p=1:Np
        L(p,1) = g(p,p+1);
    end

    % Get the left bound of the prediction
    y_params  = F;
    u_params = L;
   
    y_pred_l = y_params*y(:)+G(:,1)'*du(:);
    
    % Compute the Np prediction
    y_pred = (y_pred_r+y_pred_l)/2;
    
    y_pred = y_pred(Np);

end