% Create Phi matrix based on forward pass data
%
% licensed under the Creative Commons Attribution-NonCommercial 4.0 

function [Phi] = phi_matrix(X,wr,wl,R)
    
    k_r = 0.5/sum(wr);
    k_l = 0.5/sum(wl);

    % Select the upper membership weights that contributed to the right-most system output
    alfa_r = k_r*wr;
    
    % Select the upper membership weights that contributed to the left-most system output
    alfa_l = k_l*wl;
       
    Phi = [];

    % Interval consequent parameters
    for i=1:R
         Phi = [Phi (alfa_r(i)+alfa_l(i))*X (alfa_r(i)-alfa_l(i))*abs(X)];
    end    
end