%% t2tsk_bp.m

%% apply the backpropagation training algorithm to the network parameters

%% M1,M2, sigma are Rxn matrix denotes the mean and std of
%% antecedent Gaussian MFs (R rules, with ant antecedent in each rule)
%% C, S are Rx(ant+1) matrix denoting the center and spread of consequents para.
%% X is input matrix, L(x)ant matrix, each row is onw input.
%% D is Lx1 vector which denotes the desired output
%% Y is a Lx1 Vector wich denotes de obtained output
%%
%% licensed under the Creative Commons Attribution-NonCommercial 4.0 


function [M,sigma]=t1tsk_bp(x,y_hat,y,M,sigma,w,y_i,eta)

    [R,ANT]=size(M);

    dE_M     = zeros(size(M));
    dE_sigma = zeros(size(sigma));

    error = (y_hat-y);

    for i=1:R
        for k=1:ANT       
            dE_M(i,k)=dE_M(i,k)+error*(y_i(i)-y)/sum(w)*w(i)*(x(k)-M(i,k))/(sigma(i,k)^2);

            dE_sigma(i,k)=dE_sigma(i,k)+error*(((x(k)-M(i,k))^2)/(sigma(i,k)^3))...
                    *(y_i(i)-y)*w(i)/sum(w);
        end
    end

    M = M - eta*dE_M;
    % sigma = sigma - eta*dE_sigma;

end