% Convert th parameters from RLS algorithm to C_r C_l parameter matrix for T2TSK FS
%
% licensed under the Creative Commons Attribution-NonCommercial 4.0 

function [C,S] = th2CS(th,R,ANT,cons_type)

    if cons_type == 1
        % Interval consequent parameters
        th = reshape(th,2*ANT,R)';
        C  = th(1:R,1:ANT);
        S  = th(1:R,ANT+1:end); 
    else
        % Crisp consequent parameters
        C  = th(1:R,:);
        S  = zeros(size(th(1:R,:)));      
    end

end