function [In_HF_noise, Out_HF_noise, In_LF_disturbance] = gen_noise(SNR,SMag,D_Low,D_High,n_steps,N)

    % Generate HF Noise
    In_HF_noise  = SMag*10^(SNR/20)*(2*rand(1,N)-1);    % Input High Frequency Noise generator switch
    Out_HF_noise = SMag*10^(SNR/20)*(2*rand(1,N)-1);    % Output High Frequency Noise generator

    In_HF_noise(1:10)  = 0;
    Out_HF_noise(1:10) = 0;
       
    setpoint = repmat([0;D_High],n_steps,1);

    step_length = ceil(N/(n_steps));       % in *s between setpoint changes

    In_LF_disturbance = reshape(repmat(setpoint,1,step_length)',step_length*length(setpoint),1);
    In_LF_disturbance = In_LF_disturbance(1:N); 
    
end