% define_coupled_tank.m
%
% Timescales in seconds
%
% Romulo Antao - 2014
%
% Last Revison -  7/2/2015

% Parameters taken from 
% A simplified type-2 fuzzy logic controller for real time control
% D. Wu

% Global variables
h = 2;                   % Timescale defined in seconds 

UHigh = 90.0;            % Control signal maximum value (75.0 cm3/s)
ULow  =  0.0;            % Control signal minimum value ( 1.0 cm3/s)

RHigh = 40.0;            % Reference signal maximum value (35.0 cm)
RLow  = 10.0;            % Reference signal minimum value  (0.2 cm)

DHigh =  16.0;           % Disturbance signal at input maximum value (16.0 cm3/s)
DLow  =   0.0;            % Disturbance signal at input minimum value ( 0.0 cm3/s)

% CONTROL PARAMETERS

nelemref = 30;          % Number of steps to test
step_length = 2000;     % 2000s between setpoint changes

% Simulink Model

sim_model = 'coupled_tank';         % Name of SIMULINK model
integrator= 'ode45';		% Name of dif. eq. solver (f. ex. ode45 or ode15s)
simoptions = simset('Solver',integrator,'MaxDataPoints',0); % Set integrator
eval(['[sizes,x0] = ' sim_model '([],[],[],0);']);    % Get initial states
set_param(sim_model, 'InitInArrayFormatMsg', 'None')

% EOF : define_coupled_tank.m