% r = gen_refSignal(setpoint,step_length,h,N)
% setpoint - vector with reference setpoints
% step_length - number of seconds between each setpoint change
% h - simulation timestep (in seconds)

function [r,N] = gen_refSignal(setpoint,step_length,h)
    
    N = length(setpoint)*step_length/h;

    r = setpoint(:);
	r = repmat(r',step_length/h,1);
	r = r(:);
	r = repmat (r,ceil(N/length(r)),1);
    r = r(1:N);
    
end