% u = gen_uSignal(setpoint,step_length,h)
% setpoint - vector with control signal values
% step_length - number of secnds between each setpoint change
% h - simulation timestep (in seconds)

function [u,N] = gen_uSignal(setpoint,step_length,h)

    N = length(setpoint)*step_length/h;

    u = setpoint(:);
	u = repmat(u',step_length/h,1);
	u = u(:);
	u = repmat (u,ceil(N/length(u)),1);
    u = u(1:N);
    
end
